/*
 * Address.java
 *
 * Created on October 15, 2004, 2:45 AM
 */

package university;
import java.io.Serializable;

/**
 * A class representing an Address.
 * @author Nathan Balon
 * University Application
 * CIS 550 - Object Oriented Programming
 * U 0f M Dearborn
 * November 7, 2004
 * @version 1.0
 */

public class Address implements Serializable, Cloneable{
    
    /** Creates a new instance of Address */
    public Address() {
    }
    
    /**
     * Creates a new instance of Address
     * @param street The street
     * @param city The city
     * @param state The state
     * @param zipcode The zipcode
     */
    public Address(String street, String city, String state, String zipcode){
        this.street = street;
        this.city = city;
        this.state = state;
        this.zipcode = zipcode;
    }
    
    /**
     * Clone a new object
     * @throws java.lang.CloneNotSupportedException Throws CloneNotSupportedException
     * @return Object a cloned object
     */
    @Override
    public Object clone()throws java.lang.CloneNotSupportedException{
        Address cloned = (Address)super.clone();
        cloned.street = new String(street);
        cloned.city = new String(city);
        cloned.state = new String(state);
        cloned.zipcode = new String(zipcode);
        return cloned;
    }
    
    /**
     * Sets the street.
     * @param street The street
     */
    public final void setStreet(String street){
        this.street = street;
    }
    
    /**
     * Returns the street.
     * @return A String representing the street
     */
    public final String getStreet(){
        return street;
    }
    
    /**
     * Sets the city.
     * @param city The city
     */
    public final void setCity(String city){
        this.city = city;
    }
    
    /**
     * Returns the city.
     * @return Returns a String representing the city.
     */
    public final String getCity(){
        return city;
    }
    
    /**
     * Sets the state.
     * @param state The state
     */
    public final void setState(String state){
        this.state = state;
    }
    
    /**
     * Returns the state.
     * @return Retruns a String of the state
     */
    public final String getState(){
        return state;
    }
    
    /**
     * Sets the zipcode.
     * @param zipcode The zipcode
     */
    public final void setZipcode(String zipcode){
        this.zipcode = zipcode;
    }
    
    /**
     * Returns the zipcode
     * @return A String of the zipcode
     */
    public final String getZipcode(){
        return zipcode;
    }
    
    /**
     * Returns a String representation of the Address.
     * @return A String representing the address
     */
    @Override
    public String toString(){
        return("Address: " + street + " " + city + ", " + state + " " + zipcode);
    }
    
    private String street;
    private String city;
    private String state;
    private String zipcode;
    
}
