/*
 * Book.java
 *
 * Created on October 15, 2004, 4:22 AM
 */

package university;

import java.io.Serializable;
import java.util.*;

/**
 * Class for Books in the university Library
 *
 * @author  Nathan Balon
 * University Application
 * CIS 550 - Object Oriented Programming
 * U 0f M Dearborn
 * November 7, 2004
 * @version 1.0
 */

public class Book implements Serializable{
    
    /** Creates a new instance of Book
     *  @param title The title of the book
     *  @param yearPublished The year the book was published
     *  @param authors The authors that wrote the book
     */
    public Book(String title, int yearPublished, String [] authors) {
        this.title = title;
        this.yearPublished = yearPublished;
        this.authors = new ArrayList();        
        for(int i = 0; i < authors.length; i++){
            this.authors.add(authors[i]);
        }
        
    }
    /** Returns The title of the book
     *  @return The title
     */
    public String getTitle(){
        return title;
    }
    
    /** Returns a String listing all of the books in the library
     *  @return A String of books
     */
    public String toString(){
        String book = (" Title: " + title + ", Year: " + yearPublished + ", Authors: ");
        for(Iterator<String> i = authors.iterator(); i.hasNext(); ){
            book += i.next();
            if(i.hasNext()){
                book += ", ";
            }
        }
        return book;
    }
    
    private String title;
    private int yearPublished;
    private ArrayList <String> authors;
}
