/*
 * BuildEmployee.java
 *
 * Created on October 21, 2004, 5:04 PM
 */

package university;

import java.io.*;
import java.util.regex.*;

/**
 * Abstract Class to build the employee information.
 *
 * @author  Nathan Balon
 * University Application
 * CIS 550 - Object Oriented Programming
 * U 0f M Dearborn
 * November 7, 2004
 * @version 1.0
 */

public abstract class EmployeeFactory extends PersonFactory{
    
    /** Creates a new instance of BuildEmployee */
    public EmployeeFactory() {
    }
    
    /** Build the Employee information entered from the console */
    protected void buildEmployeeInfo(){
        this.buildPersonInfo();
        this.buildSalaryInfo();        
    }
    
    private void buildSalaryInfo(){
        boolean validInput = false;
        while(!validInput){
            // get the salary of the employee
            System.out.print("Enter the Salary: ");
            try{
                String input = console.readLine();
                Pattern p = Pattern.compile("[0-9]+");
                Matcher m = p.matcher(input);
                boolean isNumber = m.matches();
                if(isNumber){
                    salary = Integer.parseInt(input);
                    validInput = true;
                }else{
                    System.out.println("Invalid input enter a number");
                }
            }
            catch(Exception e){
                System.err.println("Invalid input enter a integer value");

            }
        }
    }
    
    protected int salary;          // salary of the employee
}
