/*
 * Faculty.java
 *
 * Created on October 11, 2004, 1:42 AM
 */

package university;

/**
 * Class for the Faculty of the university.
 * @author  Nathan Balon
 * University Application
 * CIS 550 - Object Oriented Programming
 * U 0f M Dearborn
 * November 7, 2004
 * @version 1.0
 */
public class Faculty extends Employee implements Cloneable{
    
    /** Creates a new instance of Faculty */
    public Faculty(){
        super();
    }
    
    /**
     * Creates a new instance of Faculty.
     * @param name The name of the Faculty member.
     * @param gender The gender of the Faculty member.
     * @param address The address of the Faculty member.
     * @param unit The unit the Faculty member belongs to.
     * @param salary The salary of the Faculty member.
     * @param status The status of the Faculty member (Adjuct or Tenured).
     * @param specialty The Faculty members area of specialty.
     */
    public Faculty(String name, Sex gender, Address address, Unit unit, 
                   int salary, FacultyStatus status, String specialty){
        super(name, gender, address, unit, salary);
        this.status = status;
        this.specialty = specialty;
    }

    @Override
    public Object clone() throws java.lang.CloneNotSupportedException{
        Faculty cloned = (Faculty)super.clone();
        cloned.status = status;
        cloned.specialty = new String(specialty);
        return cloned;
    }    
    
    /**
     * The Faculty members area of specialty.
     * @return String A String representing the Faculty member area of specialty.
     */
    final public String getSpecialty(){
        return specialty;
    }
    
    /**
     * Set the facutly members specialty.
     * @param specialty The Faculty members area of specialty.
     */
    final public void setSpecialty(String specialty){
        this.specialty = specialty;
    }
    
    /**
     * Retunrs the Faculty Status if the Faculty member if tenured or adjuct.
     * @return FacutltyStatus 
     */
    final public FacultyStatus getStatus(){
        return status;
    }
    
    /**
     * Set the status of the Faculty.
     * @param status The status of the faculty member (adjuct or tenured).
     */
    final public void setStatus(FacultyStatus status){
        this.status = status;
    }
    
    /**
     * Returns a String representation of the Faculty member.
     * @return String A string representation of the Faculty member.
     */
    @Override
    public String toString(){
        return (super.toString() + ", Specialty: " + specialty + 
                ", Status: " + status + "\n");
    }
    
    private FacultyStatus status;
    private String specialty;
}
