/*
 * BuildFaculty.java
 *
 * Created on October 21, 2004, 5:05 PM
 */

package university;

import java.io.IOException;
import java.util.regex.*;

/**
 * Builds a new faculty member from information entered into the console
 *
 * @author  Nathan Balon
 * University Application
 * CIS 550 - Object Oriented Programming
 * U 0f M Dearborn
 * November 7, 2004
 * @version 1.0
 */

public class FacultyFactory extends EmployeeFactory implements Build{
    
    /** Creates a new instance of BuildFaculty */
    public FacultyFactory() {

    }
    
    /** Builds a new instance of Faculty from the information entered from the console
      * @return Person a new instance of faculty that was created
      */
    public Person build(){
        this.buildEmployeeInfo();
        int choice = 0;
        // accept the choice tenured or adjuct
        while(choice < 1 || choice > 2 ){
            System.out.println("Adjuct or Tenure?");
            System.out.println("\t1- Tenure");
            System.out.println("\t2- Adjuct");

            try{
                String input = console.readLine();
                // check that the input is a number
                Pattern p = Pattern.compile("[1-2]");
                Matcher m = p.matcher(input);
                boolean isNumber = m.matches();
                // if a number parse it
                if(isNumber){
                    choice = Integer.parseInt(input);
                }else{
                    System.out.println("Invalid input");
                }
            }
            catch(Exception e){
                System.err.println("Error: You must enter an integer");
                e.printStackTrace();
            }
        }
        // set the facutly members status to tenure or adjuct
        switch(choice){
            case 1:
                status = FacultyStatus.TENURE;
                break;
            case 2:
                status = FacultyStatus.ADJUCT;
                break;

            default:
                System.err.println("Invalid value entered.");               
        }        
        // get the facutly members area of specialty
        System.out.print("Enter area of specialty: ");
        try{
            specialty = console.readLine();
        }
        catch(IOException e){
            System.err.println("ERROR: Invalid input");
        }
        // create a new facutly member and return it
        Person p = new Faculty(name, gender, address, unit, salary, status, specialty);
        return p;
    }
    
    protected FacultyStatus status;               // status of the faculty member
    protected String specialty;                   // specialty of faculty member
}
