/*
 * BuildGraduate.java
 *
 * Created on October 21, 2004, 5:04 PM
 */

package university;

/**
 * Builds a Graduate student from the information entered in from the console. 
 *
 * @author  Nathan Balon
 * University Application
 * CIS 550 - Object Oriented Programming
 * U 0f M Dearborn
 * November 7, 2004
 * @version 1.0
 */

public class GraduateFactory extends StudentFactory implements Build{
    
    /** Creates a new instance of BuildGraduate */
    public GraduateFactory() {
    }
    
    /** Builds a new instance of graduate student.
     *  @return Person the new graduate student
     */
    public Person build(){
        this.buildPersonInfo();
        int choice = 0;
        // get the choice of masters or phd student
        while(choice < 1 || choice > 2 ){
            System.out.println("Enter graduate level :");
            System.out.println("\t1- Masters");
            System.out.println("\t2- PHD");   
            try{
                choice = Integer.parseInt(console.readLine());
            }
            catch(Exception e){
                System.err.println("Error: You must enter an integer");
            }
        }
        // set the level of the graduate student
        switch(choice){
            case 1:
                level = GraduateLevel.MASTERS;
                break;
            case 2:
                level = GraduateLevel.PHD;
                break;

            default:
                System.err.println("Invalid value entered.");               
        }
        // Create a new instance of gradute student and return it
        Person p = new Graduate(name, gender, address, unit, level);
        return p;
    }
    
    private GraduateLevel level;        
}
