/*
 * PersonAdapter.java
 *
 * Created on November 11, 2004, 10:04 PM
 */

package university;

import java.rmi.*;

/**
 * Interface for Person adpater so that the class already created in the
 * the Person hierarchy can be used as remote objects. 
 *
 * @author  Nathan Balon
 * University Application
 * CIS 550 - Object Oriented Programming
 * U 0f M Dearborn
 * November 7, 2004
 * @version 1.0
 */

public interface PersonAdapter extends java.rmi.Remote{
    
   /**
     * Returns the name of a person
     * @return The name of the person
     */
    public String getName() throws RemoteException;
    
    /**
     * Set the persons name to a new name.
     * @param name The name of the person.
     */  
    public void setName(String name) throws RemoteException;
    
    /**
     * Returns the sex of a person
     * @return The gender of the person
     */
    public Sex getGender() throws RemoteException;
    
    /**
     * Returns the unit a person belongs to.
     * @return The unit that the person belongs to
     */
    public Unit getAffiliation() throws RemoteException;
    
    /**
     * Returns the ID of a person.
     * @return The ID of the person
     */
    public int getID() throws RemoteException;

    /**
     * Get the Address of the Person.
     * @return The Address of the Person.
     */
    public Address getAddress() throws RemoteException;

    /**
     * Get a description of the Person.
     * @return A String representing a Person.
     */
    public String printDescription() throws RemoteException;
   
    
    public static final String SERVICENAME = "PersonAdapter";
}
