/*
 * PersonList.java
 *
 * Created on November 11, 2004, 10:41 AM
 */



package university;


import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;
import java.util.Vector;

/**
 * Interface for the PersonList.
 *
 * @author  Nathan Balon
 * University Application
 * CIS 550 - Object Oriented Programming
 * U 0f M Dearborn
 * November 7, 2004
 * @version 1.0
 */

public interface PersonList extends Remote{
    
    /**
     * Adds a person to the remote directory.
     * @param person The person to be added to the list.
     */
    public void addPerson(PersonAdapter person) throws RemoteException;
   
    /**
     * Remove a person to the remote directory.
     * @param ID The ID number of the person to be removed from the list.
     */       
    public void removePerson(int ID) throws RemoteException;
    
    /**
     *  Lists all people that are contained in the remote directory.
     *  @return String a string listing all people in the list.
     */    
    public String ListAll() throws RemoteException;

}