/*
 * BuildStaff.java
 *
 * Created on October 21, 2004, 5:06 PM
 */

package university;

import java.io.IOException;
import java.util.regex.*;
/**
 * Factroy builds a Staff member from the information entered in from the console. 
 *
 * @author  Nathan Balon
 * University Application
 * CIS 550 - Object Oriented Programming
 * U 0f M Dearborn
 * November 7, 2004
 * @version 1.0
 */

public class StaffFactory extends EmployeeFactory implements Build{
    
    /** Creates a new instance of BuildStaff */
    public StaffFactory() {
    }
    
    /** Build a new staff member from the information entered in the console.
     *  @return Person the new staff.
     */
    public Person build(){
        this.buildEmployeeInfo();
        int choice = 0;
        while(choice < 1 || choice > 2 ){
            System.out.println("Parttime or Fulltime?");
            System.out.println("\t1- Parttime");
            System.out.println("\t2- Fulltime");
            try{
                String input = console.readLine();
                Pattern p = Pattern.compile("[1-2]");
                Matcher m = p.matcher(input);
                boolean isNumber = m.matches();
                // if a number parse it
                if(isNumber){
                    choice = Integer.parseInt(input);
                }else{
                    System.out.println("Invalid input");
                }
            }
            catch(IOException e){
                System.err.println("Error: You must enter an integer");
            }
        }
        switch(choice){
            case 1:
                status = StaffStatus.PARTTIME;
                break;
            case 2:
                status = StaffStatus.FULLTIME;
                break;
            default:
                System.err.println("Invalid value entered.");               
        }        
        System.out.print("Enter job title: ");
        try{
            title = console.readLine();
        }
        catch(IOException e){
            System.err.println("ERROR: Invalid input");
        }
        Person p = new Staff(name, gender, address, unit, salary, status, title);
        return p;
    }
    
    protected StaffStatus status;
    protected String title;    
}
