/*
 * Undergraduate.java
 *
 * Created on October 11, 2004, 1:41 AM
 */

package university;

/**
 * Class for undergraduate student in the university.
 * @author  Nathan Balon
 * University Application
 * CIS 550 - Object Oriented Programming
 * U 0f M Dearborn
 * November 7, 2004
 * @version 1.0
 */


public class Undergraduate extends Student {
    
    /** Creates a new instance of Undergraduate */
    public Undergraduate() {
        super();
    }
    
    /**
     * Creates a new instance of an Undergraduate student.
     */
    public Undergraduate(String name, Sex gender, Address address, 
                         Unit unit, UndergraduateLevel level) {
        super(name, gender, address, unit);
        this.level = level;
        this.gpa = "NA";
    }

     /**
     * Creates a new instance of an Undergraduate student.
     */
    public Undergraduate(String name, Sex gender, Address address, 
                         Unit unit, UndergraduateLevel level, String gpa) {
        super(name, gender, address, unit);
        this.level = level;
        this.gpa = gpa;
    }   
    /**
     * Clone a new object
     * @throws java.lang.CloneNotSupportedException Throws CloneNotSupportedException
     * @return Object a cloned object
     */    
    @Override
    public Object clone() throws java.lang.CloneNotSupportedException{
        Undergraduate cloned = (Undergraduate)super.clone();
        cloned.level = level;
        return cloned;
    }
        
    /**
     * Get the Undergraduate students grade level.
     * @return UndergraduateLevel The students grade level.
     */
    public final UndergraduateLevel getStatus(){
        return level;
    }
    
    /**
     * Set the Undergraduate students grade level.
     * @param level The grade level.
     */
    public final void setStatus(UndergraduateLevel level){
        this.level = level;
    }
    
    /**
     * Returns a String representing the Undergraduate student.
     * @return String A string representing a Undergrauate student.
     */
    @Override
    public String toString(){
        return(super.toString() + ", Status: " + level + ", gpa: " + gpa + "\n");
    }
    
    private UndergraduateLevel level;
    private String gpa;
}
