/*
 * CreateUnits.java
 *
 * Created on October 22, 2004, 1:19 AM
 */

package university;

/**
 * Class to build all the units of the university
 *
 * @author  Nathan Balon
 * University Application
 * CIS 550 - Object Oriented Programming
 * U 0f M Dearborn
 * November 7, 2004
 * @version 1.0
 */
public class UnitsFactory {
    
    /** Creates a new instance of CreateUnits */
    public UnitsFactory() {
    }
    
    /** create builds all the units that belong to the university */
    static void create(){
        Address a = new Address("4901 Evergreen", "Dearborn", "MI", "48128");
        lib = (Library)Library.create("Mardigian Library", a);
        String [] auth = new String[] {"Kerigan", "Ritchie"};
        Book book = new Book("C Programming Language", 1988 , auth);        
        lib.addBook(book);
        book = new Book("Effective C++", 1995, new String[] {"Meyers"});
        lib.addBook(book);
        cis = (CIS) CIS.create("CIS Department", a);
        cis.addLanguage("C++");
        cis.addLanguage("Java");
        cis.addLanguage("Perl");
        Addmissions.create("Addmissions", a);
        addmissions = (Addmissions)Addmissions.getInstance();
        HR.create("Human Resource Department", a);
        hr = (HR)HR.getInstance();
        a = new Address("19000 Hubbard Drive", "Dearborn", "MI", "48126");
        Education.create("Education Department", a);
        education = (Education)Education.getInstance();
    }
    
    static Unit getLibrary(){
        return lib;
    }
    
    static Unit getCIS(){
        return cis;
    }
    
    static Unit getEducation(){
        return education;
    }
    
    static Unit getHR(){
        return hr;
    }
    
    static Unit getAddmissions(){
        return addmissions;
    }
    
    private static Library lib;
    private static CIS cis;
    private static Education education;
    private static HR hr;
    private static Addmissions addmissions;
    
}
