/*
 * Main.java
 *
 * Created on October 19, 2004, 12:51 AM
 */

package university;

import java.io.*;
import java.util.*;
import java.util.regex.*;

/**
 * Main entry point to the program.
 * @author  Nathan Balon
 * University Application
 * CIS 550 - Object Oriented Programming
 * U 0f M Dearborn
 * November 7, 2004
 * @version 1.0
 */

public class UniversityApplication {     
    /**
     * Main The main entry point to the program.
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        int choice = 0;
        DirectoryFacade directory = null;
        // Create a BufferedReader to read input from the console
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        // Build all the unit of the university
        UnitsFactory.create();
        // create the directory

        // streams to read and write the file
        ObjectOutputStream fileOut = null;
        ObjectInputStream fileIn = null;
        // file contain all people in the university directory
        File outputFile = new File("directory.txt"); 

        try{
            if(outputFile.exists()){
                // read the file in the contains the directory and id number
                fileIn = new ObjectInputStream(new BufferedInputStream(new FileInputStream(outputFile)));   
                directory = (DirectoryFacade)fileIn.readObject(); 
                ID id = ID.getFactory();
                Integer i = (Integer)fileIn.readObject();
                // set the id to the next id from file
                id.setId(i);
            }else{
                outputFile.createNewFile();
                directory = new DirectoryFacade();
            }

        }
        catch(Exception e){
            
        }
        System.out.println("Welcome to the University Directory!!");
        while(choice != 7){
            // display the university menu
            Menu.displayMainMenu();
            try{
                // read user input from console and validate
                String input = in.readLine();
                Pattern p = Pattern.compile("[1-7]");
                Matcher m = p.matcher(input);
                boolean isNumber = m.matches();
                if(isNumber){
                    choice = Integer.parseInt(input);
                }else{
                    System.out.println("Invalid input");
                }                
                switch(choice){
                    // Create a new person for the university                       
                    case 1:
                        // Create a new Person
                        Person per = PersonFactory.createPerson();
                        // Add the newly created person to the univeristy directory
                        directory.add(per);
                        System.out.println(per.getName() + " was succesfully " +
                                           "added to the University Directory");
                        break;
                    case 2:
                        // List all people in the university directory
                        System.out.println("\n" + directory.listAll());
                        break;
                    case 3:
                        // display all people who of a category
                        System.out.println(directory.displayCategory());
                        break;
                    case 4:
                        // display all people who are affiliated a unit
                        System.out.println(directory.displayUnit());
                        break;
                    case 5:
                        // List the size of directory 
                        System.out.println(directory.size());
                        break;
                    case 6:
                        // search for a person by name or id
                        Person person = directory.search();
                        if(person == null){
                            System.out.println("\nPerson not found in directory.");
                        }
                        else{
                            System.out.println("\nFound:");
                            System.out.println(person);
                        }
                        break;
                    case 7:
                        // exit the university program
                        System.out.println("Exiting University Directory Program");
                        // write the directory and next id number to file
                        fileOut = new ObjectOutputStream(new BufferedOutputStream
                                            (new FileOutputStream(outputFile))); 
                        fileOut.writeObject(directory);
                        fileOut.writeObject(new Integer(ID.getFactory().getNextId()));
                        fileOut.flush();
                        fileOut.close();
                     //   fileOut.writeObject(ID.getFactory());
                        System.exit(0);
                        break;
                    default: 
                        System.out.println("Invalid Entery");
                }
            }
            catch(IOException e){
                System.err.println("ERROR in Main");
                e.printStackTrace();
            }
        }
    }
}
